/**
 * \file  fifo.h
 * \brief Entete de fifo.c
 */

#ifndef FIFO_H
#define FIFO_H

#include "lib_ksinu.h"

/**************************************************************************************
 Entierement fait par Martin Ludovic
**************************************************************************************/

/************************************************
 Manipulation d'une pile fifo
************************************************/

/// Initialise un pile.
void liste_init (l_fifo* liste);

/// Ajoute un nouveau processus a la pile.
void liste_add_pid (l_fifo* liste, int pid);

/// Retourne le num du processus dont il faut executer une instruction.
int liste_next_pid (l_fifo* liste);

/// Supprime un processus de la pile.
int liste_supp_pid (l_fifo* liste, int pid);

/// Ajoute une nouvelle page a la pile.
void liste_add_page (l_fifo* liste, int page);

/// Retourne le num de la plus vielle page
int liste_old_page (l_fifo* liste);

/// Actualise l'age d'une page (qd on y accede)
int liste_acces_page (l_fifo* liste, int page);

/// Supprime une page de la pile.
int liste_supp_page (l_fifo* liste, int page);

/// Retourne la taille de la liste
int liste_taille (l_fifo* liste);

/// Retourne un tableau d'entiers representant la liste des processus
int *liste_enum_pid (l_fifo* liste);

#endif
