/**
   @file ksinu.c
   Source contenant le main. Permet egalement l'initialisation de certaines variables.
*/

#include "lib_ksinu.h"
#include "systeme.h"
#include <signal.h>


int main (int argc, char *argv[]) {
  int mem_d;
  int i;
  char* nom;
  int p;

  // Initialisation des memoires
  init_mem();
  if (init_swap() == -1)
    return -1;
  // Initialisation de quelques variables
  quantum = 1;
  liste_proc = malloc(sizeof(l_fifo));
  liste_pages = malloc(sizeof(l_fifo));
  liste_init(liste_proc);
  liste_init(liste_pages);
  for (i=0 ; i<N_MAX_PROC ; i++) {
    table_capture[i] = NULL;
  }

  /*******************************************************
   Degugage
  *******************************************************/

  signal(SIGUSR1,top_horloge_handler);

  nom = malloc(9);
  printf("Lancer_prog\n");
  lancer_prog("a.objet",0);
  lancer_prog("a.objet",0);
  //  lancer_prog("b.objet",0);
  lancer_prog("c.objet",0);
  lancer_prog("c.objet",0);
  lancer_prog("c.objet",0);

  p =0;
  for (i=0 ; (i<40)&&(p!=-1) ; i++) {
    printf("%d (%d)\n",i,p);

    if (i<20) {
      sprintf(nom,"f_%d.mem",i);
      mem_d=open(nom,O_CREAT|O_TRUNC|O_RDWR,0666);
      write(mem_d,mem,NPP*NMPPP*T_MOT);
      close(mem_d);
    }

    p = liste_next_pid(liste_proc);

    if (p!=-1)
      next_inst(p);

  }
  
  // Image de la mem a la fin
  mem_d=open("./f_fin.mem",O_CREAT|O_TRUNC|O_RDWR,0666);
  write(mem_d,mem,NPP*NMPPP*T_MOT);
  close(mem_d);

  return 0;
}
