/**
  @file signaux.h
  Entete de signaux.c
*/

#ifndef SIGNAUX_H
#define SIGNAUX_H

#include "lib_ksinu.h"


/// Ajoute un signal a intercepte au processus
void add_sig (int pid, signal_t *sig);

/// Recherche si le processus intercepte le signal
signal_t* rechercher_sig (int pid, int sig);

/// Supprime un signal a intercepter de la liste des signaux du processus
int supp_sig (int pid, int sig);


/// Supprime tous les signaux a intercepter de la liste des signaux du processus
void supp_all_sig (int pid);

/// Fonction permettant de traduire un code ksinu en constante bibliotheque
int sig_ksinu2lib (int k_sig);

/// Fonction inverse de sig_ksinu2lib
int sig_lib2ksinu (int l_sig);

#endif
