
#include "lib_ksinu.h"


int main (int argc, char *argv[]) {
  page_t page_mem,page_swap;
  mot_t mot_swap,mot_mem;
  int i,j;
  int num_page_swap,num_page_suivante;
  int mem_d;

  for (i=0 ; i<4 ; i++) {
    mot_mem[i] = (octet_t)0;
    mot_swap[i] = (octet_t)0;
  }
  printf("Coucou\n");
  // Ouverture du fichier simulant la mem secondaire
  if ((swap_d=open("./f.swap",O_RDWR|O_CREAT|O_TRUNC,0666)) == -1) {
    fprintf(stderr,"Impossible d'ouvrir ou de creer le fihier swap\n");
    return -1;
  }
  printf("Fichier ouvert\n");
  // Creation d'un swap 'vide'
  // Remplissage du swap pour qu'il fasse NPPS*NMPPP*T_MOT*8 octets
  for (i=0 ; i<NMPPP ; i++) { // Page vide
    memcpy(page_swap[i], mot_swap, T_MOT);
  }
  for (i=0 ; i<NPPS ; i++) {
    if (write(swap_d,page_swap,T_PAGE) != T_PAGE) {
      fprintf(stderr,"Impossible d'initialiser le fihier swap\n");
      return -1;
    }
  }
  if (lseek(swap_d,0,SEEK_SET) == -1) {
    return -1;
  }
  // Creation de la table des pages libres du swap
  num_page_suivante = NMPPP*T_MOT - 1; // Les NMPPP*T_MOT 1eres pages sont stockees ds la mem RAM
  num_page_swap = num_page_suivante + 1;
  while (num_page_swap != NO_MORE_SWAP) {
    // Constitution d'une page contenant des numeros de pages libres
    for (i=0 ; i<NMPPP ; i++) {
      for (j=0 ; j<T_MOT ; j++) {
	if (num_page_swap >= NPPS)
	  num_page_swap = NO_MORE_SWAP;
	mot_swap[j] = (octet_t)num_page_swap;
	if (num_page_swap != NO_MORE_SWAP)
	  num_page_swap++;
      }
      memcpy(page_swap[i], mot_swap, T_MOT);
    }
    // Ecriture de la page
    if (lseek(swap_d,num_page_suivante*T_PAGE,SEEK_SET) == -1) {
      return -1;
    }
    if (write(swap_d,page_swap,T_PAGE) != T_PAGE) {
      return -1;
    }
    num_page_suivante = num_page_swap-1;
  }
  // Initialisation de la mem principale
  // Initialisation de la 1ere page
  // Le 1er mot contient le plus petit pid libre
  mot_mem[3] = (octet_t)DEBUT_T_PROC;
  memcpy(page_mem[0], mot_mem, T_MOT);
  // Initialisation de la table des processus
  mot_mem[3] = (octet_t)0;
  for (i=1 ; i<N_MAX_PROC+1 ; i++) {
    mot_mem[2] = (octet_t)PP_NULL;
    memcpy(page_mem[i], mot_mem, T_MOT);
  }
  // Initialisation de la table des pages libres
  mot_mem[0] = (octet_t)2; // le plus petit num de page mem lire
  mot_mem[1] = (octet_t)0; // position courante ds la table des pages swap libres
  mot_mem[2] = (octet_t)PAGE_VIDE;
  mot_mem[3] = (octet_t)PAGE_VIDE;
  for (i=N_MAX_PROC+1 ; i<NMPPP ; i++) {
    if (i == N_MAX_PROC+2) {
      mot_mem[0] = (octet_t)PAGE_VIDE;
      mot_mem[1] = (octet_t)PAGE_VIDE;
    }
    memcpy(page_mem[i], mot_mem, T_MOT);
  }
  memcpy(mem[NUM_PAGE_META], page_mem, T_PAGE);
  // Initialisation de la 2eme page
  for (i=0 ; i<NMPPP ; i++) {
    for (j=0 ; j<T_MOT ; j++) {
      mot_mem[j] = (octet_t)j+i*T_MOT;
    }
    memcpy(page_mem[i], mot_mem, T_MOT);
  }
  memcpy(mem[NUM_PAGE_SWAP], page_mem, T_PAGE);

  mem_d=open("./f.mem",O_CREAT|O_TRUNC|O_RDWR,0666);
  write(mem_d,mem,NPP*NMPPP*T_MOT);

  return 0;
}

